/[gentoo-x86]/eclass/java-vm-2.eclass
Gentoo

Diff of /eclass/java-vm-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.11 Revision 1.17
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2004 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/java-vm-2.eclass,v 1.11 2006/09/10 20:59:11 betelgeuse Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/java-vm-2.eclass,v 1.17 2007/05/07 15:51:29 betelgeuse Exp $
4 4
5# ----------------------------------------------------------------------------- 5# -----------------------------------------------------------------------------
6# @eclass-begin 6# @eclass-begin
7# @eclass-shortdesc Java Virtual Machine eclass 7# @eclass-shortdesc Java Virtual Machine eclass
8# @eclass-maintainer java@gentoo.org 8# @eclass-maintainer java@gentoo.org
10# This eclass provides functionality which assists with installing 10# This eclass provides functionality which assists with installing
11# virtual machines, and ensures that they are recognized by java-config. 11# virtual machines, and ensures that they are recognized by java-config.
12# 12#
13# ----------------------------------------------------------------------------- 13# -----------------------------------------------------------------------------
14 14
15inherit eutils 15inherit eutils fdo-mime
16 16
17DEPEND=" 17DEPEND="
18 =dev-java/java-config-2.0* 18 =dev-java/java-config-2.0*
19 >=sys-apps/portage-2.1" 19 >=sys-apps/portage-2.1"
20RDEPEND=" 20RDEPEND="
21 =dev-java/java-config-2.0*" 21 =dev-java/java-config-2.0*
22
23# If the VM supports generation-1, we need to depend on java-config-1
24if [[ ${JAVA_SUPPORTS_GENERATION_1} == 'true' ]]; then
25 DEPEND="${DEPEND} =dev-java/java-config-1.3*" 22 =dev-java/java-config-1.3*"
26 RDEPEND="${RDEPEND} =dev-java/java-config-1.3*"
27fi
28 23
29export WANT_JAVA_CONFIG=2 24export WANT_JAVA_CONFIG=2
30
31if [[ "${SLOT}" != "0" ]]; then
32 VMHANDLE=${PN}-${SLOT}
33else
34 VMHANDLE=${PN}
35fi
36 25
37JAVA_VM_CONFIG_DIR="/usr/share/java-config-2/vm" 26JAVA_VM_CONFIG_DIR="/usr/share/java-config-2/vm"
38JAVA_VM_DIR="/usr/lib/jvm" 27JAVA_VM_DIR="/usr/lib/jvm"
39 28
40EXPORT_FUNCTIONS pkg_postinst pkg_prerm 29EXPORT_FUNCTIONS pkg_setup pkg_postinst pkg_prerm pkg_postrm
30
31java-vm-2_pkg_setup() {
32 if [[ "${SLOT}" != "0" ]]; then
33 VMHANDLE=${PN}-${SLOT}
34 else
35 VMHANDLE=${PN}
36 fi
37}
41 38
42java-vm-2_pkg_postinst() { 39java-vm-2_pkg_postinst() {
43 # Set the generation-2 system VM, if it isn't set 40 # Set the generation-2 system VM, if it isn't set
44 if [[ -z "$(java-config-2 -f)" ]]; then 41 if [[ -z "$(java-config-2 -f)" ]]; then
45 java_set_default_vm_ 42 java_set_default_vm_
60 fi 57 fi
61 ewarn "Setting generation-1 system-vm to ${VMHANDLE}" 58 ewarn "Setting generation-1 system-vm to ${VMHANDLE}"
62 java-config-1 --set-system-vm=${P} 2>/dev/null 59 java-config-1 --set-system-vm=${P} 2>/dev/null
63 # dirty check to see if we are upgrading current generation-1 system vm 60 # dirty check to see if we are upgrading current generation-1 system vm
64 elif [[ "${systemvm1}" = ${VMHANDLE}* ]]; then 61 elif [[ "${systemvm1}" = ${VMHANDLE}* ]]; then
65 einfo "Emerging the current generation-1 system-vm..." 62 einfo "Emerging the current generation-1 system-vm..."
66 einfo "Updating its config files." 63 einfo "Updating its config files."
67 java-config-1 --set-system-vm=${P} 2>/dev/null 64 java-config-1 --set-system-vm=${P} 2>/dev/null
68 # dirty check to see if current system vm is a jre - replace it with 65 # dirty check to see if current system vm is a jre - replace it with
69 elif [[ "${systemvm1}" = *jre* ]]; then 66 elif [[ "${systemvm1}" = *jre* ]]; then
70 ewarn "Current generation-1 system-vm is a JRE" 67 ewarn "Current generation-1 system-vm is a JRE"
71 ewarn "For the new and old Java systems to coexist," 68 ewarn "For the new and old Java systems to coexist,"
72 ewarn "the generation-1 system-vm must be a JDK." 69 ewarn "the generation-1 system-vm must be a JDK."
73 ewarn "Setting generation-1 system-vm to ${VMHANDLE}" 70 ewarn "Setting generation-1 system-vm to ${VMHANDLE}"
74 java-config-1 --set-system-vm=${P} 2>/dev/null 71 java-config-1 --set-system-vm=${P} 2>/dev/null
75 fi 72 fi
76 # else... some other VM is being updated, so we don't have to worry 73 # else... some other VM is being updated, so we don't have to worry
77 else 74 else
78 einfo "JREs and 1.5+ JDKs are not supported for use with generation-1." 75 einfo "JREs and 1.5+ JDKs are not supported for use with generation-1."
79 einfo "This is because generation-1 is only for use for building packages." 76 einfo "This is because generation-1 is only for use for building packages."
80 einfo "Only generation-2 should be used by end-users," 77 einfo "Only generation-2 should be used by end-users,"
81 einfo "where all JREs and JDKs will be available" 78 einfo "where all JREs and JDKs will be available"
82 fi 79 fi
83 80
81 echo
82
83 java-vm_check-nsplugin
84 java_mozilla_clean_
85 fdo-mime_desktop_database_update
86}
87
88java-vm_check-nsplugin() {
89 local libdir
90 if [[ ${VMHANDLE} =~ emul-linux-x86 ]]; then
91 libdir=lib32
92 else
93 libdir=lib
94 fi
84 # Install a default nsplugin if we don't already have one 95 # Install a default nsplugin if we don't already have one
85 if has nsplugin ${IUSE} && use nsplugin; then 96 if has nsplugin ${IUSE} && use nsplugin; then
86 if [[ ! -f /usr/lib/nsbrowser/plugins/javaplugin.so ]]; then 97 if [[ ! -f /usr/${libdir}/nsbrowser/plugins/javaplugin.so ]]; then
87 eselect java-nsplugin set ${VMHANDLE} 98 einfo "No system nsplugin currently set."
99 java-vm_set-nsplugin
100 else
101 einfo "System nsplugin is already set, not changing it."
88 fi 102 fi
103 einfo "You can change nsplugin with eselect java-nsplugin."
104 fi
105}
106
107java-vm_set-nsplugin() {
108 local extra_args
109 if use amd64; then
110 if [[ ${VMHANDLE} =~ emul-linux-x86 ]]; then
111 extra_args="32bit"
112 else
113 extra_args="64bit"
89 fi 114 fi
90 115 einfo "Setting ${extra_args} nsplugin to ${VMHANDLE}"
91 java_mozilla_clean_ 116 else
117 einfo "Setting nsplugin to ${VMHANDLE}..."
118 fi
119 eselect java-nsplugin set ${extra_args} ${VMHANDLE}
92} 120}
93 121
94java-vm-2_pkg_prerm() { 122java-vm-2_pkg_prerm() {
95 if [[ "$(java-config -f 2>/dev/null)" == "${VMHANDLE}" ]]; then 123 if [[ "$(java-config -f 2>/dev/null)" == "${VMHANDLE}" ]]; then
96 ewarn "It appears you are removing your system-vm!" 124 ewarn "It appears you are removing your system-vm!"
97 ewarn "Please run java-config -L to list available VMs," 125 ewarn "Please run java-config -L to list available VMs,"
98 ewarn "then use java-config -S to set a new system-vm!" 126 ewarn "then use java-config -S to set a new system-vm!"
99 fi 127 fi
128}
129
130java-vm-2_pkg_postrm() {
131 fdo-mime_desktop_database_update
100} 132}
101 133
102java_set_default_vm_() { 134java_set_default_vm_() {
103 java-config-2 --set-system-vm="${VMHANDLE}" 135 java-config-2 --set-system-vm="${VMHANDLE}"
104 136
135 -e "/^LDPATH=.*lib\\/\\\"/s|\"\\(.*\\)\"|\"\\1${platform}/:\\1${platform}/server/\"|" \ 167 -e "/^LDPATH=.*lib\\/\\\"/s|\"\\(.*\\)\"|\"\\1${platform}/:\\1${platform}/server/\"|" \
136 < ${source_env_file} \ 168 < ${source_env_file} \
137 > ${env_file} || die "sed failed" 169 > ${env_file} || die "sed failed"
138 170
139 echo "VMHANDLE=\"${VMHANDLE}\"" >> ${env_file} 171 echo "VMHANDLE=\"${VMHANDLE}\"" >> ${env_file}
140 172
141 # generation-1 compatibility 173 # generation-1 compatibility
142 # respect both variables for now... 174 # respect both variables for now...
143 if [[ ${JAVA_SUPPORTS_GENERATION_1} == 'true' && ${JAVA_VM_NO_GENERATION1} != 'true' ]]; then 175 if [[ ${JAVA_SUPPORTS_GENERATION_1} == 'true' && ${JAVA_VM_NO_GENERATION1} != 'true' ]]; then
144 einfo "Enabling generation-1 compatibility..." 176 einfo "Enabling generation-1 compatibility..."
145 dodir /etc/env.d/java # generation-1 compatibility 177 dodir /etc/env.d/java # generation-1 compatibility

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.17

  ViewVC Help
Powered by ViewVC 1.1.20